{Ce lecteur de fichier MP3 a t developp par Scarabee.
 Il permet de lister tous les MP3 d'un rpertoire puis de les couter.

 Le 20 Janvier 2002.

 sscarabee07@voila.fr

 Si vous faites une amlioration de ces sources, je serais content de les voir !}

unit UnitPrincipale;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, MPlayer, ExtCtrls, Buttons, ShellCtrls,
  mmsystem; // mmsystem est utile pour modifier le volume sonore

type
  TFormLecteurMP3 = class(TForm)
    ButtonListerMP3: TButton;
    TreeViewMP3: TTreeView;  // Affichage de toute l'arborescence des fichiers MP3
    ShellTreeViewMP3: TShellTreeView;   // Permet de selectionner un rpertoire
    MediaPlayerMP3: TMediaPlayer;
    TimerMP3: TTimer;
    ProgressBarMP3: TProgressBar;
    Label1: TLabel;
    LabelTempsMp3: TLabel;
    LabelDefilement: TLabel;
    ImagePrecedent: TImage;
    ImageSuivant: TImage;
    ImageLecture: TImage;
    ImagePause: TImage;
    ImageArret: TImage;
    TimerDefilement: TTimer;
    TrackBarMP3: TTrackBar;

{Ces fonctions dcoulent d'venements prdfinies}
    procedure ButtonListerMP3Click(Sender: TObject);
    procedure TreeViewMP3DblClick(Sender: TObject);
    procedure TimerMP3Timer(Sender: TObject);
    procedure ImageLectureClick(Sender: TObject);
    procedure ImagePrecedentClick(Sender: TObject);
    procedure TreeViewMP3KeyPress(Sender: TObject; var Key: Char);
    procedure ImagePauseClick(Sender: TObject);
    procedure ImageArretClick(Sender: TObject);
    procedure ImageSuivantClick(Sender: TObject);
    procedure TimerDefilementTimer(Sender: TObject);
    procedure TrackBarMP3Change(Sender: TObject);
    procedure ProgressBarMP3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure RemplirTableauNomMP3Defilement(Nom : string; temps : Longword);
    procedure SetMPVolume(MP : TMediaPlayer; Volume : Integer);
    procedure TrouverFichier(Chemin : String ; Masque : String);
    procedure TrouverRepertoire(Chemin : String);
    procedure Affichage(chemin : string; i : integer);
    Procedure AfficherSousRepertoire(Chemin : string);
    function RenvoyerCheminCorrespondant(NumeroNoeud : integer) : string;
  end;


{Ceci est un record permettant de dclarer un enregistrement de donnes.
 Ici on enregistre 2  chaines de caracteres : le chemin complet du mp3 et
 son nom.}
type
  TTableauMP3 = record
     Chemin : String;
     MP3 : String;
  end;


var
  FormLecteurMP3: TFormLecteurMP3;
  NombreMp3,UnDePlus : Integer;
  TableauMP3 : Array of TTableauMP3;  // Tableau correspondant au record ci-dessus
  NomDuMp3Defilement : Array of String;  // Tableau qui permet le dfilement du texte dans le Label
  NomMp3 : string;
  EtreEnPause : boolean; // Savoir si on est en cours de lecture d'un mp3 ou pas


implementation

{$R *.dfm}



//****************************************************************************\\

{Ces 3 fonctions permettent de dcouper des chaines de caracteres en fonction
 d'une sous-chaine. Etant dfini au debut de la zone d'implmentation, il est
 inutile de les dclarer.}

function droite(substr: string; s: string): string;
begin
  if pos(substr,s)=0 then result:='' else
    result:=copy(s, pos(substr, s)+length(substr), length(s)-pos(substr, s)+length(substr));
end;

function droiteDroite(substr: string; s: string): string;
{============================================================================}
{ fonction qui renvoie la sous chaine de caractre situ  droite de la sous }
{ chaine substr situe la plus  droite                                      }
{ ex: si substr = '\' et S= 'truc\tr\essai.exe droiteDroite renvoie essai.exe}
{============================================================================}
begin
  Repeat
    S:=droite(substr,s);
  until pos(substr,s)=0;
  result:=S;
end;

function gauche(substr: string; s: string): string;
{============================================================================}
{ fonction qui renvoie la sous chaine de caractre situ  gauche de la sous }
{ chaine substr                                                              }
{ ex: si substr = '\' et S= 'truc\tr\essai.exe' gauche renvoie truc           }
{============================================================================}
begin
  result:=copy(s, 1, pos(substr, s)-1);
end;

//****************************************************************************\\



{Clique sur le bouton LISTER}
procedure TFormLecteurMP3.ButtonListerMP3Click(Sender: TObject);
var
    i : integer;
    Repertoire : string;
begin
   NombreMp3 :=0;
   TreeViewMP3.Items.Clear;
   ImageArretClick(Self); // arreter un son en cours
   fillchar(TableauMP3,sizeof(TableauMP3),0);   // vider tout le tableau


   {determine le repertoire  scruter}
   Repertoire := ShellTreeViewMP3.Path; // On recupere le repertoire selectionn

   {On regarde si le dernier caractere de la chaine represantant le repertoire est bien un "\".
   En effet, si on recupere un chemin racine = "E:\"
           si on recupere un chemin non racine = "E:\aaaaa\bbbbb"

   Ainsi dans le deuxieme cas, il faut rajouter le "\" pour avoir un chemin syntaxiquement exact.}

   if CompareStr(copy(Repertoire,length(Repertoire),1),'\')<>0 then
       Repertoire := Repertoire + '\';

   TrouverRepertoire(Repertoire);  // appel de la procedure TrouverRepertoire


   for i := 0 to Length(TableauMP3)-1 do
   begin
     Application.ProcessMessages; // permet que l'affichage du treeview en temps rel

     {Ici on fait la difference entre le rseau local et votre ordinateur. Si le chemin
     commence par "\\" (comme par exemple "\\OrdinateurA\aaa\bbb\") alors on est sur le rseau et
     j'enleve ces "\\".}
     if copy(TableauMP3[i].Chemin,1,2)= '\\' then  // alors on est sur le rseau
        Affichage(copy(TableauMP3[i].Chemin,3,length(TableauMP3[i].Chemin)-2),i)    // j'enleve les 2 '\\'
     else // on n'est par sur le rseau local
        Affichage(TableauMP3[i].Chemin,i);
   end;


   TreeViewMP3.SortType := stText; // permet quand l'affichage est termin, de trier le treeview
   if TreeViewMP3.Items.GetFirstNode <> nil then // si le premier noeud existe
        TreeViewMP3.Items.GetFirstNode.Expanded := TRUE; // developpe le debut de l'arborescene
end;



{Trouve tous les sous repertoire  partir d'un repertoire initial}
procedure  TFormLecteurMP3.TrouverRepertoire(Chemin : String);
var
  Recherche : TSearchRec ;
  Trouver : Boolean;

begin
  {On arrive dans un repertoire, on cherche tous les mp3 puis on cherche les repertoires.
  Si on trouve un repertoire, on "rentre dedans" et on recommence le processus...}

  TrouverFichier(Chemin,'*.mp3');  // Permet de lister tous les fichiers determins d'un repertoire
  Try
    Trouver := (FindFirst(Chemin+'*.*',faDirectory,Recherche) = 0) ;
    while (Trouver) do
    begin
      {"." tant le meme repertoire (evite une boucle), ".." tant le repertoire pere}
      If (Recherche.Name <> '.') and (Recherche.Name <> '..') and ((Recherche.Attr and faDirectory) <> 0) Then
      Begin
        TrouverRepertoire(Chemin+Recherche.Name+'\');
        Trouver := (FindNext(Recherche) = 0) ;
      end
      else
        Trouver := (FindNext(Recherche) = 0);
    end;
  Finally
    FindClose(Recherche) ; { <= IMPERATIF pour librer ressources Win32 }
  end;

end;


{Trouve tout les fichier d'un rpertoire}
Procedure TFormLecteurMP3.TrouverFichier(Chemin : String ; Masque : String);
var
  Recherche : TSearchRec ;
  Trouver : Boolean;

begin
  Try
    Trouver := (FindFirst(Chemin+Masque,FaAnyFile,Recherche) = 0) ;
    while (Trouver) do
    begin
      setlength(TableauMP3,NombreMp3+1); // tableau dynamique car on ne connait pas le nombre de MP3
      TableauMP3[NombreMp3].Chemin := (Chemin+Recherche.Name);  // chemin + le nom
      TableauMP3[NombreMp3].MP3 := copy(Recherche.Name,1,Length(Recherche.Name)-4);  // le nom sans ".mp3"
      inc(NombreMp3); // connaitre le nombre de MP3 trouvs
      Trouver := (FindNext(Recherche) = 0) ;
    end;
  Finally
    FindClose(Recherche) ; { <= IMPERATIF pour librer ressources Win32 }
  end;
end;



{Afficher dans le Treeview des mp3}
procedure TFormLecteurMP3.Affichage(chemin : string; i : integer);
var
  TEMPO : String;
begin
     TEMPO := chemin;
     if pos('\',TEMPO) = 0 then  // fichier ce trouvant  la racine
     begin
       TreeViewMP3.Items.AddChild(nil,TableauMP3[i].MP3) ;
     end
     else
     begin
       {Si il y a au moins un sous repertoire}
       AfficherSousRepertoire(chemin);
     end;
end;

{Renvoie le chemin suceptible d'etre deja dans l'arbre}
function TFormLecteurMP3.RenvoyerCheminCorrespondant(NumeroNoeud : integer) : string;
var
  NomParent : string;
  Noeud : TTreeNode;
begin
  NomParent := '';
  Noeud := TreeViewMP3.Items[NumeroNoeud];

  While Noeud.Parent <> nil do  // reconstitution du chemin en ajoutant les "\"
  begin
    NomParent :=  Noeud.Parent.Text +'\'+  NomParent;
    Noeud := Noeud.Parent;
  end;
   Application.ProcessMessages;
   result := NomParent;
end;


{Afficher dans le Treeview les sous repertoires des mp3}
procedure TFormLecteurMP3.AfficherSousRepertoire(Chemin : string);
var
   TEMPO,Noeud,PossibleCheminIdentique : String;
   MyTreeNode1, MyTreeNode2: TTreeNode;
   i : integer;
   NoeudExisteDeja : boolean; // pour eviter les doublons

begin
    TEMPO := Chemin;
    MyTreeNode2 := nil;
    MyTreeNode1 := nil;
    While (pos('\',TEMPO) <> 0) do // tant que l'on trouve un "\" dans le chemin
    begin
      NoeudExisteDeja := FALSE;

      {Voir fonctions chaines au debut de l'implmentation}
      Noeud := gauche('\',TEMPO);
      TEMPO := droite(Noeud+'\',TEMPO);

      {On regarde si le nouveau noeud est deja dans le treeview}
      for i:=0 to TreeViewMP3.Items.Count -1 do
      begin
         if (comparestr(Noeud,TreeViewMP3.Items[i].Text)=0) then
         begin
            PossibleCheminIdentique := gauche(TEMPO,Chemin); // revoie une chaine avec "\"  la fin
// Pour Test  //showmessage('nouveau : '+PossibleCheminIdentique+#13+#13+'ancien : '+RenvoyerCheminCorrespondant(i+1));
            if PossibleCheminIdentique = RenvoyerCheminCorrespondant(i+1) then
            begin
              NoeudExisteDeja := TRUE;
              MyTreeNode1 := TreeViewMP3.Items[i];
              MyTreeNode2 := TreeViewMP3.Items[i];
            end;
         end;
      end;

     if not NoeudExisteDeja then // si le noeud trouv n'a pas encore t placer 
     begin
      MyTreeNode1 := TreeViewMP3.Items.AddChild(MyTreeNode2, Noeud); { Ajoute un noeud racine }
      MyTreeNode2 := MyTreeNode1;
     end;
    end;
    { Ajoute un noeud enfant au noeud ajout }
    TreeViewMP3.Items.AddChild(MyTreeNode1,copy(TEMPO,1,Length(TEMPO)-4));
end;


{Lecture du mp3}
procedure TFormLecteurMP3.TreeViewMP3DblClick(Sender: TObject);
var
  NomMp3,NomParent,NomCheminComplet : string;
  Selection,TeteArbre : TTreeNode;
begin
   NomMp3 := '';
   NomParent := '';
   if TreeViewMP3.Selected.HasChildren = FALSE then
   begin
   TeteArbre := TreeViewMP3.TopItem;
   Selection := TreeViewMP3.Selected;
   NomMp3 := TreeViewMP3.Selected.Text; // noeud sur lequel l'utilisateur double clique
     While TreeViewMP3.Selected.Parent <> nil do  // reconstitution du chemin en ajoutant les "\"
     begin
        TreeViewMP3.Font.Color := clBlack;
        NomParent :=  TreeViewMP3.Selected.Parent.Text +'\'+  NomParent;
        TreeViewMP3.Selected := TreeViewMP3.Selected.Parent;
     end;
   Application.ProcessMessages;
   TreeViewMP3.Font.Color := clWhite;
   TreeViewMP3.TopItem := TeteArbre; // Pour remettre l'arbre comme il tait avant
   Selection.Selected := TRUE;
   end;

{assemblage des # parties du chemin}
   if NomMp3 <> '' then
   begin
      EtreEnPause := FALSE;
      if copy(TableauMP3[0].Chemin,1,2) = '\\' then   // si on est sur le rseau local
        NomCheminComplet := '\\' + NomParent  + NomMp3 + '.mp3'
      else
        NomCheminComplet := NomParent  + NomMp3 + '.mp3';

      fillchar(NomDuMp3Defilement,sizeof(NomDuMp3Defilement),0);   // vider tout le tableau
      {Initialisation pour la lecture du mp3}
      MediaPlayerMP3.Close;
      MediaPlayerMP3.FileName := NomCheminComplet;
      MediaPlayerMP3.Open;
      MediaPlayerMP3.TimeFormat:= tfMilliseconds;
      ProgressBarMP3.Max := MediaPlayerMP3.TrackLength[1];
      ProgressBarMP3.Position := 0;
      MediaPlayerMP3.Play;
      RemplirTableauNomMP3Defilement(NomMp3,MediaPlayerMP3.TrackLength[1]);

      TimerMP3.Enabled := TRUE;  {Activation du timer}
   end;
end;


{Gestion du temps du mp3 avec un timer : en cours et lorsqu'il arrive en fin de lecture}
procedure TFormLecteurMP3.TimerMP3Timer(Sender: TObject);
var
  SecondeTotal : Integer;
  Minute,Seconde : byte;
  
begin
   if MediaPlayerMP3.Position = MediaPlayerMP3.TrackLength[1] then // fin du Mp3
   begin
      if (TreeViewMP3.Selected.GetNext <> nil) then // pas la fin de l'arbre
      begin
        TreeViewMP3.Selected := TreeViewMP3.Selected.GetNext;
        While TreeViewMP3.Selected.HasChildren = TRUE do
        begin
           TreeViewMP3.Selected := TreeViewMP3.Selected.GetNext;
        end;
        TreeViewMP3DblClick(Self); // nouvelle lecture
      end
      else
      begin // arriv  la fin de l'arbre, on recommence du debut
         TreeViewMP3.Selected := TreeViewMP3.Items.GetFirstNode;
         While TreeViewMP3.Selected.HasChildren = TRUE do
         begin
            TreeViewMP3.Selected := TreeViewMP3.Selected.GetNext;
         end;
         TreeViewMP3DblClick(Self); // nouvelle lecture }
      end;
   end
   else  // Mp3 en cours de lecture
   begin
   Application.ProcessMessages;
   ProgressBarMP3.Position := MediaPlayerMP3.Position; {position de la barre de progression}
   {Affichage du temps restant}
   SecondeTotal := round(MediaPlayerMP3.Position / 1000);  // transformation de milliseconde en seconde
   Minute := (SecondeTotal div 60);    // en divise les seconde par 60 = minutes
   Seconde := (SecondeTotal mod 60);  // le reste de la division precedente = secondes restantes

   if Minute < 10 then // Gestion de l'criture du temps avec 2 chiffre ou 1 seul chiffre
   begin
     if Seconde < 10 then
        LabelTempsMp3.Caption :=  '0'+inttostr(Minute)+' : '+'0'+inttostr(Seconde)
     else
        LabelTempsMp3.Caption :=  '0'+inttostr(Minute)+' : '+inttostr(Seconde);
   end
   else
   begin
     if Seconde < 10 then
        LabelTempsMp3.Caption :=  '0'+inttostr(Minute)+' : '+'0'+inttostr(Seconde)
     else
        LabelTempsMp3.Caption :=  '0'+inttostr(Minute)+' : '+inttostr(Seconde);
   end;
   end;
end;


{Changer la position sur le morceau de musique}
procedure TFormLecteurMP3.ProgressBarMP3MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  i : extended;
  SecondeTotal : Integer;
  Minute,Seconde : byte;

begin
    if TimerMP3.Enabled = TRUE then
    begin
      {position de la barre de progression}
      i := (X / (ProgressBarMP3.Width-3)) * MediaPlayerMP3.TrackLength[1];
      TimerMP3.Enabled := FALSE;
      MediaPlayerMP3.StartPos := Round(i); // arrondir
      MediaPlayerMP3.Play;
      ProgressBarMP3.Position := MediaPlayerMP3.Position;

   {Affichage du temps restant}
   SecondeTotal := round(MediaPlayerMP3.Position / 1000); // identique  la procedure ci-dessus
   Minute := (SecondeTotal div 60);
   Seconde := (SecondeTotal mod 60);

   if Minute < 10 then
   begin
     if Seconde < 10 then
        LabelTempsMp3.Caption :=  '0'+inttostr(Minute)+' : '+'0'+inttostr(Seconde)
     else
        LabelTempsMp3.Caption :=  '0'+inttostr(Minute)+' : '+inttostr(Seconde);
   end
   else
   begin
     if Seconde < 10 then
        LabelTempsMp3.Caption :=  '0'+inttostr(Minute)+' : '+'0'+inttostr(Seconde)
     else
        LabelTempsMp3.Caption :=  '0'+inttostr(Minute)+' : '+inttostr(Seconde);
   end;

      TimerMP3.Enabled := TRUE;
   end;
end;



{Permet de lancer la lecture lorsque l'on appuie sur "entrer"}
procedure TFormLecteurMP3.TreeViewMP3KeyPress(Sender: TObject;
  var Key: Char);
begin
  if (key = #13) and (TreeViewMP3.Selected <> nil) then
    TreeViewMP3DblClick(Self);
  key := #0; // evite d'entendre un son lorsque l'on clique sur "entrer"
end;



{Lecture d'un MP3}
procedure TFormLecteurMP3.ImageLectureClick(Sender: TObject);
begin
  if (TreeViewMP3.Selected <> nil) then
  begin
     if EtreEnPause = TRUE then
        ImagePauseClick(Self)
     else
       TreeViewMP3DblClick(Self);
  end;
end;



{Le MP3 prcdent}
procedure TFormLecteurMP3.ImagePrecedentClick(Sender: TObject);
begin
   if (TreeViewMP3.Selected <> TreeViewMP3.Items.GetFirstNode)  then // si on n'est pas sur le premier noeud
   begin
    TreeViewMP3.Selected := TreeViewMP3.Selected.GetPrev;
    While TreeViewMP3.Selected.HasChildren = TRUE do
    begin
       if (TreeViewMP3.Selected = TreeViewMP3.Items.GetFirstNode) then // si c'est le premier noeud
       begin
          TreeViewMP3.Selected := TreeViewMP3.Selected.GetNext;
          break; // permet de sortir du While directement
       end
       else
          TreeViewMP3.Selected := TreeViewMP3.Selected.GetPrev;
    end;
   end;
   TreeViewMP3DblClick(Self); // nouvelle lecture }
end;



{Lorsque l'utilisateur clique sur pause}
procedure TFormLecteurMP3.ImagePauseClick(Sender: TObject);
begin
  if (TreeViewMP3.Selected <> nil) and (TimerMP3.Enabled = TRUE) then
     MediaPlayerMP3.Pause;
  if EtreEnPause = TRUE then
      EtreEnPause := FALSE
  else
     EtreEnPause := TRUE;
end;



{Lorsque l'utilisateur clique sur stop}
procedure TFormLecteurMP3.ImageArretClick(Sender: TObject);
begin
  if (TimerMP3.Enabled = TRUE) then   // remettre tout  zero
  begin
    MediaPlayerMP3.Close;
    TimerMP3.Enabled := FALSE;
    NomMp3 := '';
    LabelTempsMp3.Caption := '00 : 00';
    ProgressBarMP3.Position := 0;
    LabelDefilement.Caption := '';
  end;
end;



{Lorsque l'utilisateur clique sur Suivant}
procedure TFormLecteurMP3.ImageSuivantClick(Sender: TObject);
begin
   if TreeViewMP3.Selected <> TreeViewMP3.Items[TreeViewMP3.Items.Count-1] then // si on n'est pas sur le dernier noeud
   begin
    TreeViewMP3.Selected := TreeViewMP3.Selected.GetNext;
    While TreeViewMP3.Selected.HasChildren = TRUE do
    begin
       if (TreeViewMP3.Selected = TreeViewMP3.Items.GetFirstNode) then // si c'est le premier noeud
       begin
          TreeViewMP3.Selected := TreeViewMP3.Selected.GetPrev;
          break; // permet de sortir du While directement
       end
       else
          TreeViewMP3.Selected := TreeViewMP3.Selected.GetNext;
    end;
   end;
   TreeViewMP3DblClick(Self); // nouvelle lecture }
end;



{Remplir le tableau de defilement :
 prendre chaque caractere du titre du mp3 + ajouter le temps}
procedure TFormLecteurMP3.RemplirTableauNomMP3Defilement(Nom : string; temps : Longword);
var
  SecondeTotal,i,j,k,m,x,y : Integer;
  Minute,Seconde : byte;
  LaMinute, LaSeconde : string;

begin
   SecondeTotal := round(temps / 1000);
   Minute := (SecondeTotal div 60);
   Seconde := (SecondeTotal mod 60);

   if Minute < 10 then
       LaMinute := '0'+inttostr(Minute)
   else
       LaMinute := inttostr(Minute);

   if Seconde < 10 then
       LaSeconde := '0'+inttostr(Seconde)
   else
       LaSeconde := inttostr(Seconde);

   for i:=0 to length(Nom)-1 do    // toutes les lettres du MP3
   begin
     setlength(NomDuMp3Defilement,i+1);
     NomDuMp3Defilement[i] := copy(Nom,i+1,1);
   end;

   for j:=i to i+1 do   // ajoute de 2 espace
   begin
      setlength(NomDuMp3Defilement,j+1);
      NomDuMp3Defilement[j] := ' ';
   end;

   setlength(NomDuMp3Defilement,j+1);  // ajout d'une paranthese
   NomDuMp3Defilement[j] := '(';

   for k := 1 to length(LaMinute) do     // Ajout des minutes
   begin
      setlength(NomDuMp3Defilement,j+k+1);
      NomDuMp3Defilement[j+k] := copy(LaMinute,k,1);
   end;

   m := j+k;
   setlength(NomDuMp3Defilement,m+1);  // ajouter les ":"
   NomDuMp3Defilement[m] := ':';

   for x := 1 to length(LaSeconde) do  // Ajouter les secondes
   begin
      setlength(NomDuMp3Defilement,m+x+1);
      NomDuMp3Defilement[m+x] := copy(LaSeconde,x,1);
   end;

   setlength(NomDuMp3Defilement,m+x+1);  // Fermer la parenthese
   NomDuMp3Defilement[m+x] := ')';

   for y:= m+x+1  to m+x+2 do  // encore 2 espaces
   begin
      setlength(NomDuMp3Defilement,y+1);
      NomDuMp3Defilement[y] := ' ';
   end;

   for y:= m+x+3  to m+x+4 do   // 2 caracteres particuliers pour sparer
   begin
      setlength(NomDuMp3Defilement,y+3);
      NomDuMp3Defilement[y+2] := '*';
   end;

   for y:= m+x+5  to m+x+6 do  // encore 2 derniers espaces
   begin
      setlength(NomDuMp3Defilement,y+5);
      NomDuMp3Defilement[y+4] := ' ';
   end;
   {Toutes les lettres sont places dans le tableau}
   UnDePlus :=0;

end;


{defilement du nom du mp3 en utilisant le timer}
procedure TFormLecteurMP3.TimerDefilementTimer(Sender: TObject);
var
  i,j,x : byte;
  Affichage : string;

begin
  if (TimerMP3.Enabled = TRUE)  and (length(NomDuMp3Defilement) <> 0) then
  begin
    Affichage := '';
    x:=0;
    {27 tant une valeur personnel qui reprsente le nombre de caracteres maximum dans mon Label
    (en majuscule)}
    if length(NomDuMp3Defilement) < 27 then  // longueur inferieur  27
    begin
      for i:=UnDePlus to length(NomDuMp3Defilement)-1 do
        Affichage := Affichage + NomDuMp3Defilement[i];

      if UnDePlus > 0 then
      begin
        for j:= 0 to UnDePlus-1 do
          Affichage := Affichage + NomDuMp3Defilement[j];

      end;
      if UnDePlus = length(NomDuMp3Defilement) then
         UnDePlus := -1;
    end
    else  // longueur superieur  la taille du label
    begin
      for i:=UnDePlus to length(NomDuMp3Defilement)-1 do
      begin
        Affichage := Affichage + NomDuMp3Defilement[i];
        inc(x);
        if x = 26 then
          break;
      end;

      if (UnDePlus > 0) and (x <> 26) then
      begin
        for j:= 0 to UnDePlus-1 do
        begin
          Affichage := Affichage + NomDuMp3Defilement[j];
          inc(x);
          if x = 26 then
            break;
        end;
      end;
      if UnDePlus = length(NomDuMp3Defilement) then
         UnDePlus := -1;
    end;
    application.ProcessMessages;
    LabelDefilement.Caption := Affichage;
    inc(UnDePlus);
  end;
end;



{Modifier le volume sonore}
procedure TFormLecteurMP3.SetMPVolume(MP : TMediaPlayer; Volume : Integer);
{ Volume: 0 - 1000 }
const 
  MCI_SETAUDIO = $0873;
  MCI_DGV_SETAUDIO_VOLUME = $4002;
  MCI_DGV_SETAUDIO_ITEM = $00800000;
  MCI_DGV_SETAUDIO_VALUE = $01000000; 

type 
  MCI_DGV_SETAUDIO_PARMS = record
  dwCallback : DWORD;
  dwItem : DWORd;
  dwValue : DWORD;
  dwOver : DWORD;
  lpstrAlgorithm : PChar;
  lpstrQuality : PChar;
end; 

var 
p : MCI_DGV_SETAUDIO_PARMS;

begin 
  p.dwCallback := 0;
  p.dwItem := MCI_DGV_SETAUDIO_VOLUME;
  p.dwValue := Volume;
  p.dwOver := 0;
  p.lpstrAlgorithm := nil;
  p.lpstrQuality := nil;
  mciSendCommand(MP.DeviceID, MCI_SETAUDIO,MCI_DGV_SETAUDIO_VALUE or MCI_DGV_SETAUDIO_ITEM, Cardinal(@p));
end; 



{Lorsque l'utilisateur change le volume}
procedure TFormLecteurMP3.TrackBarMP3Change(Sender: TObject);
begin
   SetMPVolume(MediaPlayerMP3,1000 - TrackBarMP3.Position);
end;

end.
